/*
   Palette-Library v1.00     (C) 1996 by The Real Adok of Hugendubelexpress

   Diese  Library  enthlt einige Funktionen, mit denen man Fadein/Fadeout-
   Effekte coden kann! In <main> ist ein Beispielprogramm,  das  dies  sehr
   eindrucksvoll  demonstriert.  <stdio.h>  mu  brigens  nur fr das Bei-
   spielprogramm eingebunden werden!
*/

#include <stdio.h>
#include <conio.h>

void delay(int hi,int lo);
void fadein(int hi,int lo);
void fadeincol(char col,int hi,int lo);
void fadeout(int hi,int lo);
void fadeoutcol(char col,int hi,int lo);
void getpal(void);
void restorecol(char col);
void restorepal(void);
void setpal(char col,char r,char g,char b);

char pal[768];

void delay(int hi,int lo)
{
  _asm
  {
    mov ax,8600h
    mov cx,word ptr hi
    mov dx,word ptr lo
    int 15h
  }
}

void fadein(int hi,int lo)
{
  char r=0,
       g=0,
       b=0,
       i=0;
  int  col=0;

  for(i=63;i>=0;i--)
  {
    for(col=0;col<=255;col++)
    {
      if((r=pal[3*col]-i)<0) r=0;
      if((g=pal[1+3*col]-i)<0) g=0;
      if((b=pal[2+3*col]-i)<0) b=0;
      setpal(col,r,g,b);
    }
    delay(hi,lo);
  }
}

void fadeincol(char col,int hi,int lo)
{
  char r=0,
       g=0,
       b=0,
       i=0;

       for(i=0;i<=63;i++)
       {
	 if(++r>pal[3*col]) r=pal[3*col];
	 if(++g>pal[1+3*col]) g=pal[1+3*col];
	 if(++b>pal[2+3*col]) b=pal[2+3*col];
	 setpal(col,r,g,b);
	 delay(hi,lo);
       }
}

void fadeout(int hi,int lo)
{
  char r=0,
       g=0,
       b=0,
       i=0;
  int  col=0;

  for(i=0;i<=63;i++)
  {
    for(col=0;col<=255;col++)
    {
      if((r=pal[3*col]-i)<0) r=0;
      if((g=pal[1+3*col]-i)<0) g=0;
      if((b=pal[2+3*col]-i)<0) b=0;
      setpal(col,r,g,b);
    }
    delay(hi,lo);
  }
}

void fadeoutcol(char col,int hi,int lo)
{
  char r=pal[3+3*col],
       g=pal[1+3*col],
       b=pal[2+3*col],
       i=0;

       for(i=63;i>=0;i--)
       {
	 if(--r<0) r=0;
	 if(--g<0) g=0;
	 if(--b<0) b=0;
	 setpal(col,r,g,b);
	 delay(hi,lo);
       }
}


void getpal(void)
{
  int  i=0,
       j=0,
       k=0;

  for(i=0;i<=255;i++)
  {
    outp(0x3c7,i);
    for(k=1;k<=3;k++)
    {
      pal[j]=inp(0x3c9);
      j++;
    }
  }
}

void restorecol(char col)
{
  setpal(col,pal[3*col],pal[1+3*col],pal[2+3*col]);
}

void restorepal(void)
{
  int i=0;

  for(i=0;i<=255;i++)
    restorecol((char)i);
}

void setpal(char col,char r,char g,char b)
{
  outp(0x3c8,col);
  outp(0x3c9,r);
  outp(0x3c9,g);
  outp(0x3c9,b);
}

void main(void)
{
  printf("Hallo!");
  getpal();
  fadeout(0,20000);
  fadein(0,20000);
}
